#include "all.h"

void reportnomemory(int *ilist)
{ /* report nomemory */
  if(!ilist)
    {
      printf("no memory for allocation, abort\n");
      exit(-1);
    }
} /* report nomemory */

void checkclock(nodes *ckt, int gate)
{ /* checkclock */
  int i;
  int tmp;
  int index;
  int ingate;

  tmp=ckt[gate]->fu.flags;

  for(i=gate;i>num_pi+1;i--)
    {
      ckt[i]->inputs = make_ilist(ckt[i-1]->inputs[0]);
      totalcktmemory += (ckt[i-1]->inputs[0]+1)*sizeof(int);
      ckt[i]->inputs[0]=0;
      
      loop_through_ilist(ckt[i-1]->inputs,index,ingate)
	{
	  if(ingate > num_pi && ingate < gate)
		add_to_itail(ckt[i]->inputs,ingate+1);
	  else if(ingate == gate)
	    add_to_itail(ckt[i]->inputs,num_pi+1);
	  else
	    add_to_itail(ckt[i]->inputs,ingate);
	}
      ckt[i]->fu.flags=ckt[i-1]->fu.flags;
      ckt[i]->funct=ckt[i-1]->funct;
      free_ilist(ckt[i-1]->inputs);
      ckt[i-1]->inputs=NULL;
      ckt[i-1]->fu.flags=0;
    }
  ckt[num_pi+1]->funct=pi;
  ckt[num_pi+1]->fu.flags=tmp;

  free_ilist(ckt[num_pi+1]->inputs);
  ckt[num_pi+1]->inputs=NULL;

  for(i=gate+1;i<=gatecnt;i++)
    {
      loop_through_ilist(ckt[i]->inputs,index,ingate)
	{
	  if(ingate > num_pi && ingate < gate)
	    ckt[i]->inputs[index]++;
	  else if(ingate == gate)
	    ckt[i]->inputs[index]= num_pi+1;
	  else
	    ;
	}
    }
  num_pi++;

  for(i=1;i<=dfflist[0];i++)
    {
      if(dfflist[i] < gate)
	dfflist[i]++;
    }

  for(i=num_pi+1;i<=gatecnt-num_po;i++)
    {
      if(ckt[i]->fu.flags == 0)

	{
	  gatecnt++;
	  num_po++;
	  ckt[gatecnt]->inputs = make_ilist(1);
	  totalcktmemory += 2*sizeof(int);
	  ckt[gatecnt]->inputs[0]=0;
	  ckt[gatecnt]->funct=po;
	  add_to_itail(ckt[gatecnt]->inputs,i);
	  ckt[gatecnt]->fu.flags=0;
	  ckt[gatecnt]->outputs=NULL;
	  ckt[i]->fu.flags++;

	}
    }
} /* checkclock */

