#include "all.h"

nodes *rreadckt(char *schfile, char *faultfile, )
/* readckt expects to receive a file name of a closed schematic file.  It
 * will read the circuit schematic language from this file and translate it
 * into the circuit graph, stored in global pointer circuit. */
{
  /* rreadckt */
  int success;

  success = r_parse (NULL, schfile /* pointer to the file name */, 0);
  if (success < 0)
    {
      fprintf (resultsout, "Parsing failed %d\n", success);
      exit (success);
    }
  else if (success == 0)
    {
      fprintf (resultsout,
 "Warning: You are using SpectralATPG on a combinational circuit -- it may be slower than EST or Podem.\n");
    }

  readfaults (faultfile);  
  return (scircuit);
} /* rreadckt */


